
import esrapy
from pprint import pprint

def tryPat(filename, message):
	print message
	print "---------------- %s ----------------"%filename
	text = file(filename).read()
	print text
	print "------------------------------------"
	print "Compiling..."
	pat = esrapy.compile(text, debug=1)
	print 'Matching against "1 + 2 * 3 + 4" returns:'
	pprint(pat.match("1 + 2 * 3 + 4", debug=1))
	return pat

tryPat("calc1.pat", "\n\nHere's a pattern for simple arithmetic:")
tryPat("calc2.pat", "\n\nHere's the same pattern using default white space:")
tryPat("calc3.pat", "\n\nHere's the same pattern with precedence added:")
pat = tryPat("calc4.pat", "\n\nHere's the same again with labels added:")
tryPat("calc5.pat", "\n\nHere's a different way of labeling:")

print "\n\nNow let's implement a calculator..."

def eval_pt(pt):
	if pt.op == 'int': return int(pt.val)
	if pt.op == '+': return eval_pt(pt.a)  + eval_pt(pt.b)
	if pt.op == '-': return eval_pt(pt.a)  - eval_pt(pt.b)
	if pt.op == '*': return eval_pt(pt.a)  * eval_pt(pt.b)
	if pt.op == '/': return eval_pt(pt.a)  / eval_pt(pt.b)
	if pt.op == '^': return eval_pt(pt.a) ** eval_pt(pt.b)
	raise "Unhandled op: %s"%pt.op

def eval(s):
	print "Expr:", s
	pt = pat.match(s)
	print "Parse tree:"
	pprint(pt)
	print "Value:", eval_pt(pt)
	print

eval("1+2*3+4")
eval("(1+2)*(3+4)")
eval("1+2*3^4")

